//*CID://+v025R~:                              update#=  110;      //+v025R~
//******************************************************************************//~v012I~
//v025:051104 (BUG)at start no input accepted(after automake input avail)//+v025I~
//v024:051103 (BUG)restore also score when restore pending game    //~v024I~
//v012:051004 dosenot write answer when in solving                 //~v012I~
//v005:050922 (BUG) GetState returns int not bool                  //~v005R~
///*                                                               //~9C09R~
//*** VC++ & MFC ***************************************************************//~9C09R~
//*       ** Board.h **                                            //~9C09R~
//******************************************************************************//~9C09R~
//*/                                                               //~9C09R~
#ifndef HEADER_BOARD
    #define HEADER_BOARD

#include    <afxwin.h>                                             //~9C25R~
#include    "wnpDef.h"                                             //~9C09R~
#include    "Pattern.h"                                            //~0102I~

#define MODE_INIT      0      //no data exist                      //~0116R~
#define MODE_NOINPUT   1      //file input end                     //~0122R~
#define MODE_FILEDATA  2      //file input end                     //~0122I~
#define MODE_KEYINDATA 3      //manual data                        //~0122R~
#define MODE_ENDQDATA  4      //made data or id of go answer       //~0122R~
#define MODE_KEYINANS  5      //manual answer input data           //~0122R~
#define MODE_OUTANS    6      //solved answer data                 //~0122R~
                                                                   //~0101I~
#define PATTERN_ID     10                                          //~0101R~
/*
================================================================================
     Hole 
================================================================================*/
class   Hole
{
public :
    Hole( int board_x, int board_y );
    ~Hole();
    void    Show( CDC* pDC,CFont *Pmemfont,int Pdownnum,BOOL PFocus,BOOL Pansmode);//~0211R~
    int     GetNum();                                              //~0129R~
    void    SetNum(int Pnum,int Pmode,int Perr);                   //~0129R~
    int     SetMemo(int Pnum);                                     //~0213R~
//  BOOL    GetState();                                            //~v005R~
    int     GetState();                                            //~v005R~
    int     GetErr();                                              //~0212R~
private :
    int	    BoardX, BoardY;                                        //~0129R~
    int     State;           //mode of board                       //~0101I~
    int     Err;           //mode of board                         //~0101I~
#define     HOLE_ERR      1                                        //~0212R~
#define     HOLE_RCHK     2                                        //~0212R~
#define     HOLE_NEXT    16    //used Next Button                  //~0212R~
#define     HOLE_NEXTERR 17    //used Next Button                  //~0212I~
#define     HOLE_PENDDATA 18   //read from file                    //~v024I~
    int     Num;           //mode of board                         //~0101I~
    int     Memo[4];                                               //~0205M~
    int     MemoCnt;                                               //~0205I~
};
/*
================================================================================
     Board 
================================================================================*/
class   Board
{
public :
    Board();
    ~Board();
    void    CreateBoard( CPattern* pat );                          //~0206R~
    void    Show(CDC* pDC,CFont *Pmemofont);                       //~0205R~
    int     GetKbFocus();                                          //~0211R~
    void    SetKbFocus(int Pnum);                                  //~0211R~
	BOOL    DropDown( CPoint point,int Pnum);                      //~0129R~
	BOOL    SetMemo(CPoint point,int Pnum);                        //~0212R~
	int     KeyProc(UINT nChar);                                   //~0206R~
    BOOL    KeyUpProc(UINT nChar);                                 //~0211R~
	CString GetMsg();                                              //~0101I~
	void    SetTempMsg(CString);                                   //~0102I~
    int     GetPath();                                             //~0129R~
    int     GetMode();                                             //~0129R~
    BOOL    ShowNumBtn();                                          //~0101I~
    void    SetNum(int Pnum,CWnd *Pwnd);                          // <--- 萔擾//~9C28I~
    int     GetNum(void);                                          //~0129R~
	void    GetInpnum(int *Pinpnum);                               //~v012R~
    void    OnClear();                                             //~9C31R~
    void    OnAnswer();                                            //~9C31I~
    void    OnMake();                                              //~9C31I~
    void    OnSetend(int Pendthreadid);                            //~0130R~
    void    OnGo(int Pendthreadsw);                                //~0122R~
    void    OnStop();                                              //~0110I~
    int     OnEndThread();                                         //~0312R~
    int     OnSuccess();                                           //~0212R~
    void    OnRchk(int Pendthreadsw);                              //~0122R~
    void    OnNext(int Pendthreadsw);                              //~0205R~
    BOOL    OnSort();                                              //~0212R~
    int     OnTimer(UINT Pid);                                     //~0212R~
	int     SetSameNum(int Pkeydownsw);                            //~0312M~
                                                                   //~0109I~
	void  Npsuberr1(int rc);                                       //~0109M~
	void  Npsuberr2(CException *E);                                //~0109M~
	void  Npsuberr3();                                             //~0109M~
	void 	CalcScore(void);                                       //~v024M~
                                                                   //~0109I~
    NPWORKT Npworkt;                                               //~0109M~
 	CWnd   *pView;                                                 //~0109I~
    CString  sProbLevel;                                           //~0211M~
	int   ActSeed;                                                 //~0212M~
                                                                  //~0108I~
    int      	FixedSeq;		//fixed seqence for next           //~0108R~
    int      	MaxFixed;		//fixed seqence                    //~0108I~
    int     Flags;

#define F_ONTRY    0x01                                            //~0129I~
#define F_ONGO     0x02	    //next ans by GO                       //~0129R~
#define F_ONNEXT   0x04                                            //~0129I~
#define F_ONRCHK   0x08     //ans by rchkmode                      //~0129R~
#define F_ONXX     0x0f     //ans by rchkmode                      //~0129I~
#define F_THREAD   0x10
#define F_ANSCHK   0x20                                            //~0129R~
#define F_MODEMAKE 0x40     //make or answer mode                  //~0129I~
#define F_MODEANS  0x80     //make or answer mode                  //~0129I~
	//~0109I~
#define F_LVLMASK  0x0f00                                          //~0130R~
#define F_LVL0     0x0100   //difficuty level                      //~0109I~
#define F_LVL1     0x0200   //difficuty level                      //~0109I~
#define F_LVL2     0x0400   //difficuty level                      //~0109I~
#define F_LVL3     0x0800   //difficuty level                      //~0109I~
                                                                   //~0109I~
#define F_DENMASK  0x0f0000
#define F_DEN0     0x010000   //density                              //~0109I~
#define F_DEN3     0x020000   //density                              //~0109I~
#define F_DEN4     0x040000   //density                              //~0109I~
#define F_DEN5     0x080000   //density                              //~0109I~
                                                                   //~0110I~
#define F_RIGID    0x100000   //rigid option                       //~0110I~
                                                                   //~0130I~
#define F_ERROR    0x01000000 //err detected                       //~0130I~
#define F_READFILE 0x02000000 //err detected                       //~v012I~
                                                                   //~0109I~
	int     Seed;                                                  //~0109I~
	int     Timeout;                                               //~0110I~
    CTime  StartTime;                                              //~0109I~
    CPattern*   pPat;                                              //~0129R~
    int      	NumCount;      //Num set count                     //~0123M~
    int      Score;                                                //~0213I~
    int      ScoreMax;                                                               //~0109I~
private :
	void    Board::Restoreprevinput( );                            //~v012I~
//  BOOL    CanMove(Hole *pHole);                                  //+v025R~
    BOOL    CanMove(Hole *pHole,int Pnum);                         //+v025I~
    BOOL    CanSetMemo(Hole *pHole);                               //~0213R~
    int     CallAns(int Popt,int *Ppdata);                         //~0205R~
    int     CallMake();                                            //~0123R~
	void    NextFocus();                                           //~0211R~
    void    PrevFocus();                                           //~0211R~
    void    SetAllAnswer();                                        //~0116R~
    int     SetNextAnswer(int Pfixedseq);                          //~0108I~
    int     OnClearSub(int Popt);                                  //~0116R~
    int     OnClearBack();                                         //~0103R~
    void    ResetErr(int Pclearnextsw);                            //~0205R~
    int     GetSol(int Pendthreadsw);                              //~0205I~
	int     CheckAnswer(int Pallsw);                               //~0312R~
	void    SaveAnswer();                                          //~0129I~
	void    SaveAnswerXnp();                                       //~0312I~
	void    SetNewNum(int by,int bx,Hole*phole,int Psortsw,int Psetanssw);//~0312R~
	int     MemoClear();                                           //~0213I~
	int     ErrClear();                                            //~0312I~
	void    CountPenalty(int Penalty);                             //~0213I~
                                                                   //~9C12I~
    Hole*       BoardMap[ MAP_SIZE ][ MAP_SIZE ];                  //~0129R~
    void    ShowGrid( CDC* pDC );                                  //~0129R~
    int         PickedX, PickedY;                                  //~0129R~
    int         Mode;                                              //~9C31R~
    int         CurNum;        //current num of cursor             //~0123R~
    CString sMsg,sTempMsg,sMsgOut,sSuccessMsg;                     //~0129R~
    int      KbFocus;                                              //~0211R~
    int      NpsubRc;                                              //~0130M~
    int      SameNum;                                              //~0206I~
    int      Shiftkey;                                             //~0206I~
    int      CongMsg;   //when wnswe ok                            //~0211I~
    CTime    TryStartTime;                                         //~0212I~
    int      TryTimeSpan;    //sec                                 //~0213R~
    int      Penalty;                                              //~0213I~
    NPWORKT  Npwtryans;                                            //~0213I~
#define PENALTY_NOTIME   4   //6*5=20min is standard(no time penalty)//~0226R~
//    score is multiplyed by 30min/elapsed time(5min unit)         //~0213I~
#define PENALTY_SAMENUM  1                                         //~0213I~
#define PENALTY_MEMO     5                                         //~0226R~
#define PENALTY_TIME    50   //for each 5 min late                 //~0226R~
#define PENALTY_ERR    100   //for each 5 min late                 //~0312I~
	
	CWinThread *pThread;                                           //~0109I~
};

#endif
